# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

$GFSH_PATH = ""
if (Get-Command gfsh -ErrorAction SilentlyContinue)
{
    $GFSH_PATH = "gfsh"
}
else
{
    $GFSH_PATH = "$env:GEODE_HOME\bin\gfsh.bat"
}

Invoke-Expression "$GFSH_PATH -e 'connect' -e 'destroy region --name=exampleRegion' -e 'stop server --name=server' -e 'stop locator --name=locator'"

Remove-Item -Path locator -Recurse -Force
Remove-Item -Path server -Recurse -Force
